#!/usr/local/bin/perl5.00503 -w

my $version = "wApua.pl 0.02dev";

package wApua;

# Copyright (c) 2000 by Axel Beckert <abe@deuxchevaux.org>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# You can reach the author by snail-mail at the following address:
#
#  Axel Beckert
#  Saarbrcker Strae 267a
#  66125 Saarbrcken, Germany

# Thanks to: 
#  Jindra Vavruska <ok1fou@yahoo.com> for bug reports an suggestions.

# wApua.pl is a browser for WML pages. Not yet ready for use...

BEGIN { push(@INC, "/home/beckert/bin"); } 
# Modify the line above to match your include path!

use strict;

use wApua::History;
use wApua::About;

use Tk;
use Tk::ROText;
#use Tk::Table;

use LWP::UserAgent;
use HTML::TokeParser;
use URI;
use URI::Escape;

### Configuration

# Proxy configuration only via environment variables at the
# moment. From the LWP::UserAgent man page:

#       $ua->env_proxy()
#           Load proxy settings from *_proxy environment variables.
#           You might specify proxies like this (sh-syntax):

#             gopher_proxy=http://proxy.my.place/
#             wais_proxy=http://proxy.my.place/
#             no_proxy="localhost,my.domain"
#             export gopher_proxy wais_proxy no_proxy

#           Csh or tcsh users should use the setenv command to
#           define these environment variables.



# Keys
my @modkeylist = qw(Alt Meta Control);
@modkeylist = qw(Alt Control) if ($ eq "MSWin32");
@modkeylist = qw(Command) if ($ eq "MacOS");

# Font
my $fontfamily = "helvetica";
my $ttfontfamily = "courier";
my $softbuttonfont = "font=-1=normal";

# Cursors
my $textcursor = "xterm"; #xterm (oder pencil)
my $waitcursor = "watch"; #watch (oder trek)
my $normalcursor = "top_left_arrow"; #top_left_arrow
my $linkcursor = "center_ptr"; #hand2

# X_cursor, arrow, based_arrow_down, based_arrow_up, boat, bogosity,
# bottom_left_corner, bottom_right_corner, bottom_side, bottom_tee,
# box_spiral, center_ptr, circle, clock, coffee_mug, cross,
# cross_reverse, crosshair, diamond_cross, dot, dotbox, double_arrow,
# draft_large, draft_small, draped_box, exchange, fleur, gobbler,
# gumby, hand1, hand2, heart, icon, iron_cross, left_ptr, left_side,
# left_tee, leftbutton, ll_angle, lr_angle, man, middlebutton, mouse,
# pencil, pirate, plus, question_arrow, right_ptr, right_side,
# right_tee, rightbutton, rtl_logo, sailboat, sb_down_arrow,
# sb_h_double_arrow, sb_left_arrow, sb_right_arrow, sb_up_arrow,
# sb_v_double_arrow, shuttle, sizing, spider, spraycan, star, target,
# tcross, top_left_arrow, top_left_corner, top_right_corner, top_side,
# top_tee, trek, ul_angle, umbrella, ur_angle, watch, xterm

# Colors, program
my ($cof, $cob) = ('#FFFFFF','#808080');
my @co = (-background => $cob,
	  -foreground => $cof);

# Colors, WAP pages
my ($cif, $cib) = ('#000000','#A6C6A6');
my @ci = (-background => $cib,
	  -foreground => $cif);

# Colors, links
my @cl = (-background => '#A6C6A6',
	  -foreground => '#FFFFFF');

# Colors, hover links
my @ca = (-background => '#000000',
	  -foreground => '#FFFFFF');

my $lhbw = 2;

# Padding
my ($sfg, $sbg) = ("#FFFFFF","#B0B0B0");
my @activecolors = (-activeforeground => $sfg,
		  -activebackground => $sbg);
my @menucolors = (@activecolors, @co);
my @padding = (-highlightbackground => $cob,
	       -highlightcolor => $cib,
	       -highlightthickness => 1,
	       -borderwidth => 2);
my @buttonpadding = (-padx => 3, -pady => 3,
		     @activecolors, @padding);
my @fieldpadding = (-selectforeground => $sfg,
		    -selectbackground => $sbg,
		    -selectborderwidth => 2,
		    @padding);


# Start URL
my $homeurl = "http://fsinfo.cs.uni-sb.de/~abe/Links/index.wml";
my $starturl = scalar @ARGV ? $ARGV[0] : $homeurl;
my ($acturl,$url) = ($starturl,$starturl);

### Initialation
my %state=();
my $card;
my $content;
my $wapua = new LWP::UserAgent;
my $wapua_headers = new HTTP::Headers
    Accept => "text/vnd.wap.wml; q=1.0, text/plain; q=0.5",
    From => 'Axel Beckert <wApua-dev@deuxchevaux.org>',
### Private Headers
#    Accept_Charset => "iso-8859-1; q=1, unicode-1-1;q=0.8",
#    Accept_Encoding => "identity; q=0.4, compress; q=0.5, gzip; q=0.9, bzip2; q=1.0",
    Accept_Language => "de; q=1.0, en-gb; q=0.9, en; q=0.8, en-us; q=0.7, nl; q=0.2, fr; q=0.1"
;

# UserAgent configuration
$wapua->agent("$version (".($wapua->agent).")");
$wapua->timeout(15);
$wapua->parse_head(0);
$wapua->env_proxy();

# Tk window
my $window = MainWindow->new(@co, -takefocus => 0,
			     -width => 420, -height => 260,
			     -borderwidth => 2,
			     -relief => "flat",
			     -title => "$version - A WAP User Agent") ;
$window->packPropagate(0);
#$window->Label(-text => "$version - A WAP User Agent",
#	       -justify => "center",
#	       -borderwidth => 3,
#	       -relief => "flat",
#	       @co)->pack(-side => "top",
#			  -fill => "x");

# Generate font names
my ($fsize,$bold,$uline,$fname,$ttname);
my %fontsizes = ( -2 => 6,
		  -1 => 8,
		   0 => 10,
		   1 => 12,
		   2 => 14 );

foreach $fsize (keys %fontsizes) {
    foreach $bold ("bold", "normal") {
	$fname = "font=$fsize=$bold";
	$ttname = "tt=$fsize=$bold";
	$window->fontCreate($fname,
			    -family => $fontfamily,
			    -weight => $bold,
			    -size => $fontsizes{$fsize});
	$window->fontCreate($ttname,
			    -family => $ttfontfamily,
			    -weight => $bold,
			    -size => $fontsizes{$fsize});
    }
}

# Navigation bar
my $navbar = $window->Frame(@co, -borderwidth => 0, -takefocus => 0);
my $locbar = $window->Frame(@co, -borderwidth => 0, -takefocus => 0);
$navbar->pack(-side => "top",
	      -fill => "x",
	      -padx => 2,
	      -pady => 2);
$locbar->pack(-side => "top",
	      -fill => "x",
	      -padx => 2,
	      -pady => 2);
my $backbutton = $navbar->Button(-text => ' Back', @co, @buttonpadding,
				 -command => \&back);
$backbutton->pack(-side => 'left');
$backbutton->bind('<Any-Leave>' => \&blankState);
$backbutton->bind('<Any-Enter>' =>  \&backState);

my $reloadbutton = $navbar->Button(-text => 'Reload',@co, @buttonpadding,
				   -command => \&reload);
$reloadbutton->pack(-side => 'left');
$reloadbutton->bind('<Any-Leave>' => \&blankState);
$reloadbutton->bind('<Any-Enter>' => \&reloadState);

my $forwardbutton = $navbar->Button(-text => 'Forward ', @co, @buttonpadding,
				 -command => \&forward);
$forwardbutton->pack(-side => 'left');
$forwardbutton->bind('<Any-Leave>' => \&blankState);
$forwardbutton->bind('<Any-Enter>' => \&forwardState);

my $homebutton = $navbar->Button(-text => 'Home', @co, @buttonpadding,
				 -command => \&home);
$homebutton->pack(-side => 'left');
$homebutton->bind('<Any-Leave>' => \&blankState);
$homebutton->bind('<Any-Enter>' => sub {
    &textState("Go home ($homeurl)"); });

my $exitbutton = $navbar->Button(-text => 'Quit', @co, @buttonpadding,
		-command => sub { exit; });
$exitbutton->pack(-side => 'right');
$exitbutton->bind('<Any-Leave>' => \&blankState);
$exitbutton->bind('<Any-Enter>' => sub {
    &textState("Exit $version"); });

my $aboutbutton = $navbar->Button(-text => 'About', @co, @buttonpadding,
		-command => sub { &fetch("about:",1); });
$aboutbutton->pack(-side => 'right');
$aboutbutton->bind('<Any-Leave>' => \&blankState);
$aboutbutton->bind('<Any-Enter>' => sub {
    &textState("About $version"); });

### Menu Test

my $menubutton = $locbar->Menubutton(-text => "Menu",
				     @buttonpadding,
				     @menucolors);
my $menu = $menubutton->menu(-tearoff => 0,
			     @menucolors);
$menubutton->pack(-side => 'left');

$menu->command(-label => 'About',    
	       -command => sub { &fetch("about:",1); },
	       -accelerator => "Help", 
	       @menucolors);
$menu->command(-label => 'Quit',    
	       -command => sub { exit; },
	       -accelerator => "Meta-Q", 
	       @menucolors);

my $hisbutton = $locbar->Menubutton(-text => "History",
				    @buttonpadding,
				    @menucolors);
my $hismenu = $hisbutton->menu(-tearoff => 1,
			       @menucolors);
$hisbutton->pack(-side => 'left');

my $history=new wApua::History(\&fetch, $forwardbutton, $hismenu, 
			       $cib, @menucolors,
			       -font => $softbuttonfont);

$menu->bind('<<MenuSelect>>' => sub {
    my $w = $Tk::event->W;
    &textState($w->entrycget('active', -label));
    $window->idletasks;
});

$locbar->Label(-text => 'URL: ', @co, -takefocus => 0)->pack(-side => 'left');
my $urlfield = $locbar->Entry(-width => 40, @co, @fieldpadding,
			      -exportselection => 1,
			      -highlightthickness => 1,
			      -takefocus => 1,
			      -textvariable => \$url);
$urlfield->pack(-side => 'left',
		-expand => 1,
		-fill => "x");
$urlfield->bind('<Any-Leave>' => \&blankState);
$urlfield->bind('<Any-Enter>' => sub {
    &textState("Insert some text and hit <Enter>... ;-)"); });

my $statusline = $window->Frame(-relief => "sunken",
				-takefocus => 0,
				-borderwidth => 1,
				@co);
my $status = $statusline->Label(-text => ' ', @co, 
				-takefocus => 0,
				-width => -1,
				-font => "font=-1=normal",
				-relief => "flat",
				-justify => "left");
my $filesize = $statusline->Label(-text => ' ', @co,
				  -takefocus => 0,
				  -font => "font=-1=normal",
				  -relief => "flat",
				  -justify => "right");
$filesize->pack(-side => 'right',
		-anchor => "e");
$status->pack(-side => 'left',
	      -anchor => "w");
#$statusline->packPropagate(0);
$statusline->pack(-side => 'bottom',
		  -fill => "x",
		  -padx => 2,
		  -pady => 2);

### WAP-Page := Browser + Do-Tag-Button-Leiste
my $wappage = $window->Frame(-borderwidth => 1,
			     -takefocus => 0,
			     -relief => "sunken",
			     # ridge, groove, flat, raised, sunken
			     @ci);
$wappage->pack(-side => 'bottom',
	       -fill => "both",
	       -padx => 2,
	       -pady => 2,
	       -expand => 1);

### Browser := Textfenster + Scrollbar
my $browser = $wappage->Scrolled("ROText",
				 -scrollbars => "oe");
$browser->ConfigSpecs(-relief => ["SELF"],
		      -takefocus => ["SELF"],
		      -borderwidth => ["SELF"],
		      -background => [("SELF", "CHILDREN")],
		      -foreground => ["SELF"]);
$browser->configure(-relief => "flat",
		    -takefocus => 0,
		    -borderwidth => "2",
		    -background => $cib);
$browser->pack(-side => 'top',
	       -fill => "both",
	       -padx => 4,
	       -padx => 4,
	       -expand => 1);
### Scrollbar
my $scrollbar = $browser->Subwidget("xscrollbar");
$scrollbar->configure(-activebackground => $cib,
		      -highlightbackground => $cib,
		      -highlightcolor => $cib,
		      -troughcolor => $cib,
		      -background => $cib,
		      -activerelief => "ridge",
		      -relief => "flat",
		      -width => 3,
		      -borderwidth => 0,
		      -takefocus => 1,
		      -elementborderwidth => 0);

### Textfenster
my $scrolled = $browser->Subwidget("scrolled");
$scrolled->configure(-selectforeground => $sfg,
		     -selectbackground => $sbg,
		     -selectborderwidth => 2,
		     -exportselection => 1,
		     -takefocus => 0,
		     -highlightthickness => 0,
		     -relief => "flat", # ridge, groove, flat, raised, sunken
		     -width => 0,
		     -height => 0,
		     -highlightbackground => $cib,
		     -wrap => "word",
		     -borderwidth => 0,
		     -padx => 0,
		     -padx => 0,
		     @ci);

### Do-Tag-Button-Leiste
my @dotagsfo = (-borderwidth => 1,
		-takefocus => 0,
		-relief => "flat",
		@ci);
my @dotagspo = (-side => 'bottom',
		-fill => "x",
		-padx => 4,
		-pady => 4);
my $dotags = $wappage->Frame(@dotagsfo);
$dotags->pack(@dotagspo);

# Generate Browser Font Tags
sub generateFontTags {
    foreach $fsize (keys %fontsizes) {
	foreach $bold ("bold", "normal") {
	    $fname = "font=$fsize=$bold";
	    foreach $uline ("ul", "nl") {
		my $ul = ($uline eq "ul"?1:0);
		$browser->tag("configure" => "$fname=$uline=none",
			      -font => $fname, @ci,
			      -underline => $ul);
		$browser->tag("configure" => "$fname=$uline=link",
			      -font => $fname, @cl,
			      -underline => $ul);
		$browser->tag("configure" => "$fname=$uline=active",
			      -font => $fname, @ca,
			      -underline => $ul);
	    }
	}
    }
}
&generateFontTags;

sub blankState   { $status->configure(-text => ''); }
sub textState    { $status->configure(-text => uri_unescape(shift)); }
sub sizeState    { $filesize->configure(-text => shift); }
sub backState    { my $text = $history->last;
		   $status->configure(-text => "Go back ($text) in history")
		       if $text; }
sub reloadState  { $status->configure(-text => 
				      "Reload the current document ($acturl)"); }
sub forwardState { my $text = $history->next;
		   $status->configure(-text => "Go forward ($text) in history")
		       if $text; }

sub scrolldown {
    $scrolled->yview(scroll => 1, "units");
}

sub scrollup {
    $scrolled->yview(scroll => -1, "units");
}

sub pagedown {
    $scrolled->yview(scroll => 1, "pages");
}

sub pageup {
    $scrolled->yview(scroll => -1, "pages");
}

### Key Bindings
my $modkey;

$window->bind('all','<Tab>','focusNext');
$window->bind('all','<<LeftTab>>','focusPrev');
$window->bind('all','<Shift-Tab>','focusPrev');

# vi
$window->bind('all',"<j>" => \&scrolldown);
$window->bind('all',"<k>" => \&scrollup);
$window->bind('all',"<h>" => \&back);
$window->bind('all',"<l>" => \&forward);

# Netscape
$window->bind('all',"<space>" => \&pagedown);
$window->bind('all',"<BackSpace>" => \&pageup);
$window->bind('all',"<Return>" => \&scrolldown);
$window->bind('all',"<minus>" => \&scrollup);

# Emacs / Netscape
$window->bind('all',"<KP_Next>" => \&pagedown);
$window->bind('all',"<KP_Prior>" => \&pageup);

$window->bind('all',"<KP_Down>" => \&scrolldown);
$window->bind('all',"<KP_Up>" => \&scrollup);
$window->bind('all',"<Control-n>" => \&scrolldown);
$window->bind('all',"<Control-p>" => \&scrollup);

# Sun
$window->bind('all',"<L2>" => \&reload);
$window->bind('all',"<Help>" => sub { &fetch("about:",1); });
$window->bind('all',"<SunProps>" => sub { &fetch("about:",1); });

foreach $modkey (@modkeylist) {
    # Emacs / Netscape
    $window->bind('all',"<$modkey-Left>" => \&back);
    $window->bind('all',"<$modkey-Right>" => \&forward);
    $window->bind('all',"<$modkey-b>" => \&back);
    $window->bind('all',"<$modkey-f>" => \&forward);
    $window->bind('all',"<$modkey-KP_Left>" => \&back);
    $window->bind('all',"<$modkey-KP_Right>" => \&forward);
    $window->bind('all',"<$modkey-q>" => sub { exit; });
    $window->bind('all',"<$modkey-r>" => \&reload);
    $window->bind('all',"<$modkey-h>" => \&home);
    $window->bind('all',"<$modkey-n>" => \&pagedown);
    $window->bind('all',"<$modkey-p>" => \&pageup);
}

# Special bindings for the location field
$urlfield->bind('<Return>', sub{&fetch($url,1,1)});
$urlfield->bind('<Control-u>', sub{$urlfield->delete(0,"end")});

# Remove some class bindings from the browser's text window
foreach (qw(Tab <LeftTab> Shift-Tab Return h j k l space BackSpace 3
	    Return minus)) {
    $scrolled->bind(ref($scrolled),      "<Any-$_>", '');
    $scrolled->bind($scrolled->toplevel, "<Any-$_>", '');
    $scrolled->bind($scrolled,           "<Any-$_>", '');
}
$scrolled->bindtags(['all',$scrolled->toplevel,$scrolled,ref($scrolled)]);

sub noglobalbind { # Keine globalen Key-Bindings fr Eingabefelder
    my $f = shift;
    $f->bindtags([$f,ref($f)]);
    $f->bind('<Tab>','focusNext');
    $f->bind('<<LeftTab>>','focusPrev');
    $f->bind('<Shift-Tab>','focusPrev');
}
&noglobalbind($urlfield);

### PopUp-Menu

#  sub MenuLabels
#  {
#   return qw[~Back ~Forward ~Reload ~Home];
#  }

#  sub BackMenuItems
#  {
#   my ($w) = @_;
#   return ['command' => '~Back', -command => \&back];
#  }

#  sub ForwardMenuItems
#  {
#   my ($w) = @_;
#   return ['command' => '~Forward', -command => \&forward];
#  }

#  sub ReloadMenuItems
#  {
#   my ($w) = @_;
#   return ['command' => '~Reload', -command => \&reload];
#  }

#  sub HomeMenuItems
#  {
#   my ($w) = @_;
#   return ['command' => '~Home', -command => \&home];
#  }


#  sub NavPopup {
#      my ($w, $X, $Y) = @_;
#      my $popup = $window->Menu(-type => "popup",
#  			      -tearoff => 0,
#  			      -popover => 'cursor',
#  			      -font => $softbuttonfont,
#  			      @menucolors);
    
#      $popup->command(-label => '~Back', 
#  		    -command => \&back,
#  		    -state => ($history->last?"normal":"disabled")
#  		    );
#      $popup->command(-label => '~Forward', 
#  		    -command => \&forward,
#  		    -state => ($history->next?"normal":"disabled"));
#      $popup->separator;
#      $popup->command(-label => '~Reload', -command => \&reload);
#      $popup->command(-label => '~Home', -command => \&home);

#      $popup->Post($X,$Y);
#      $popup->toplevel->mwmDecoration(-menu => 0, 
#    			  -maximize => 0, 
#    			  -minimize => 0, 
#    			  -resizeh => 0, 
#    			  -title => 0);
#  }

#  $window->bind(ref($scrolled),'<ButtonPress-3>', ['PostPopupMenu', Ev('X'), Ev('Y')]);

# History function

my %backbuttons = ();

sub configBack {
    my $state = shift;
    $backbutton->configure(-state => $state);
    foreach (values %backbuttons) {
	$_->configure(-state => $state);
    }
}

sub back {
    &fetch($history->back,0,0)
	if ($history->last);
    $forwardbutton->configure(-state => "normal")
	if $history->next;
    &configBack("disabled") unless $history->last;
}

sub forward {
    &fetch($history->forward,0,0)
	if $history->next;
    $forwardbutton->configure(-state => "disabled")
	unless $history->next;
    &configBack("normal") if $history->last;
}

sub reload {
    &fetch($acturl,0,0);
}

sub home {
    &fetch($homeurl,1,1);
}

sub modifyGlobalCursor {
    my $cursor = shift;
    $window->configure(-cursor => $cursor);
    $browser->configure(-cursor => $cursor);
    $scrolled->configure(-cursor => $cursor);
}

# Function for getting and displaying new pages.
sub fetch {
    # URL give as parameter
    $url = shift;
    my $push = shift;
    my $correct = shift;
#    my $reload = shift;
    if ($correct && ($url !~ m(^((ht|f)tps?|file|gopher|mailto|news|nntp|about|wapua(\.pl)?|wtai):)i)) {
	if ($url =~ /^ftp/i) {
	    $url = "ftp://$url";
	} else {
	    $url = "http://$url";
	}
    }
    $url = URI->new_abs($url,$acturl)->as_string;
    my $fetchurl = $url;
    $fetchurl =~ s/\#.*$//;
    &textState("Fetching $fetchurl...");
    &sizeState("");
    $window->configure(-title => "$version: $url",
		       -cursor => $waitcursor);
    $window->update;

    if ($url =~ m/\#(.*)$/) {
	$card = $1;
	$card =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    } else {
	$card = "";
    }
    %backbuttons = ();
    $dotags->destroy;
    $dotags = $wappage->Frame(@dotagsfo);
    $dotags->pack(@dotagspo);

    # Debugging output: History
    #foreach ($history->allHistory) {
    #	print "$_ ";
    #}
    #print "\n";

    # push URL on the history stack
    if ($push) {
	$history->push($url);
	$backbutton->configure(-state => "normal");
	$forwardbutton->configure(-state => "disabled");
    }

    # Fetch page
    if ($url =~ /^(wapua(\.pl)?|about):/i) {
	$acturl=$url;
	display(preparser(new wApua::About($version)->as_string));
    } else {
	my ($acttemp,$temp)=($acturl,$url);
	$temp =~ s/\#.*$//;
	$acttemp =~ s/\#.*$//;

#	if (($acttemp  $temp) || $reload) { } 
#	else { print "No new request. Using cached data.\n\n"; }

	$content = "";
	my $request = new HTTP::Request('GET', $url, $wapua_headers);
	print $request->as_string;
	my $response = $wapua->request($request,\&reqcallback);
	print $response->as_string;
	$history->set($acturl=$url=$response->base);

	my $seite=preparser($content);
	if ($response->is_success) {
	    if ($response->header('Content-Type') eq "text/plain") {
		$browser->configure(-wrap => "none");
		$browser->delete("0.0","end");
		$browser->insert("end", $content);
		$browser->configure(-cursor => $normalcursor);
	    } elsif ($seite !~ m|^(<.*>)? ?<!DOCTYPE WML PUBLIC [\"\']-//WAPFORUM//DTD WML 1\.1//EN[\"\'] [\"\']([^<>\"]*)[\"\']> ?<|is) {
		$browser->configure(-wrap => "none");
		$browser->delete("0.0","end");
		$browser->insert("end", "No WML page:\n" => ("font=0=bold=nl=none"),
				 $content => ("ttfont=0=normal=nl=none"));
		$browser->configure(-cursor => $normalcursor);
	    } else {
		my $xml = $1;
		my $dtd = $2;
		warn "Incorrect DTD: $dtd"
		    if $dtd ne "http://www.wapforum.org/DTD/wml_1.1.xml";
		if ($xml =~ /^\s*$/) {
		    warn "Missing XML version tag!";
		} elsif ($xml !~ m|<\?xml version=[\"\']\d+\.\d+[\"\']\?>|) {
		    warn "Wrong XML version tag: $xml";
		}
		$seite =~ s(^(<.*>)? ?<!DOCTYPE WML PUBLIC "-//WAPFORUM//DTD WML 1\.1//EN" "[^<>\"]*"> ?<)(<)is;
		display($seite);
	    }
	} else { # Fehler
	    $browser->configure(-wrap => "none");
	    $browser->delete("0.0","end");
	    $browser->insert("end", 
			     "Error: " => ("font=0=bold=nl=none"),
			     $response->status_line => ("font=0=normal=nl=none"));
	    $browser->configure(-cursor => $normalcursor);
	}
	&sizeState("Deck size: ".length($content)." Bytes");
    }
    &textState("Done.");
    $window->configure(-cursor => $normalcursor);
}

sub reqcallback {
    my($data, $response, $protocol) = @_;
    $content .= $data;
    #print $response->header('Content-Length')."\n";
    if ($response->header('Content-Length')) {
	my $contleng = $response->header('Content-Length');
	&textState("Received ".length($content)." of $contleng Bytes (".
		   int(100*length($content)/$contleng)."%)...");
	# Tk::ProgressBar
    } else {
	&textState("Received ".length($content)." Bytes...");
    }
    $window->update;
}

sub parsespaces {
    my $seite = shift;
    $seite =~ s/\s+/ /gs;
    $seite =~ s=\s*(</?(card|p|br|wml|t[dr]|table|head|template|access|meta)(\s[^<>]*)?/?>)((<[^<>]+>)*)\s*=$1$4=gi;
    return $seite;
}

sub parseentities {
    my $seite = shift;
    $seite =~ s/&\#(34|x22);/\&quot;/gi;
    $seite =~ s/&\#(38|x26);/\&amp;/gi;
    $seite =~ s/&\#(39|x27);/\&apos;/gi;
    $seite =~ s/&\#(60|x40);/\&lt;/gi;
    $seite =~ s/&\#(62|x42);/\&gt;/gi;
    $seite =~ s/&\#(160|xA0);/\&nbsp;/gi;
    $seite =~ s/&\#(173|xAD);/\&shy;/gi;

    $seite =~ s/&\#(\d+);/pack("C", $1)/eg;
    $seite =~ s/&\#x([a-fA-F0-9]+);/pack("C", hex($1))/eg;

    return $seite;
}

sub parsecdata {
    my $seite = shift;
    $seite =~ s/&(.*?);/&!$1;/g;

    $seite =~ s/&/&amp;/g;
    $seite =~ s/</&lt;/g;
    $seite =~ s/>/&gt;/g;
    $seite =~ s/\"/&quot;/g;
    $seite =~ s/\'/&apos;/g;
    $seite =~ s/\\\]\\\]/\]\]/g;

    return $seite;
}


sub preparser {
    my $seite = shift;

    # Delete redundant white spaces
    my $newseite = "";
    while ($seite =~ m=<pre(\s[^<>]+)?>(.*)</pre>|<!CDATA\s+\[\[(.*?)\]\]>=s) {
	my $before = $`;
	my $between;
	if (defined $3) {
	    $between = $3;
	}
	my $match = $&;
	$seite = $';

	if ($& =~ /^<pre/) {
	    $newseite .= 
		&parsespaces(&parseentities($before)).
		&parseentities($match);
	} else {
	    $newseite .= (&parsespaces(&parseentities($before)) .
			  "<pre>" .
			  &parsecdata($between) .
			  "</pre>");
	}
    }
    $newseite .= &parsespaces(&parseentities($seite));
    return $newseite;
}

sub syntaxwarn {
    my $expected = shift;
    my $found = shift;
    warn <<EOF;
WML Syntax error: Mismatched closing tag!
    + Expected closing tag: </$expected>
    + Found closing tag: </$found>
EOF
}

sub syntaxignore {
    my $tag = shift;
    if (0 < scalar @_) {
	$tag = shift;
	warn "Ignored unknown tag: <$tag>";
	my %hash = %{shift()};
	foreach (keys %hash) {
	    #warn "  $_: $hash{$_}";
	}
    } else {
	warn "Ignored unknown tag: <$tag>";
    }
}

sub display {
    # Content as parameter
    my $seite = shift;
    my $foobar; # temporary data
    my @tagstack = ();
    my $font = "font=0=normal=nl=none";
    my $fontsize;
    my @fontstack = ($font);
    my $end = 0;
    my $link = 0;
    my $token;
    my $cardstate=0;
    my $dostate=0;
    my $doid=0;
    my %dobuttons=();
    my $doname;
    my $dolabel;
    my $anchorstate = 0;
    my $ul = 0;
    my %tabledata=();
    my $table=0;
    my $topbrowser=$browser;

    # clear browser window
    $browser->configure(-wrap => "word");
    $browser->delete("0.0","end");

    # initialize parser.
    my $parser = HTML::TokeParser->new(\$seite);
    while (($token = $parser->get_token) || !$end) {
	my @tokendata = @{$token};
	# Debugging
	#foreach (@tagstack) {
	#    print "$_ ";
	#}
	#print "\n";
        if ($tokendata[0] eq "T") { # plain text
	    $tokendata[1] =~ s/&quot;/\"/g;
	    $tokendata[1] =~ s/&amp;/\&/g;
	    $tokendata[1] =~ s/&apos;/\'/g;
	    $tokendata[1] =~ s/&lt;/</g;
	    $tokendata[1] =~ s/&gt;/>/g;
	    $tokendata[1] =~ s/&nbsp;/ /g;
	    $tokendata[1] =~ s/&shy;/-/g;
	    $tokendata[1] =~ s/&!(.*?);/&$1;/g;
	    $browser->insert("end", $tokendata[1], $font) if $cardstate;
	    #print "$font: $tokendata[1]\n" if $cardstate;
          } elsif ($tokendata[0] eq "S") {
              if ($tokendata[1] eq "br/") { # line break
		  $browser->insert("end", "\n", $font) if $cardstate;
	      } elsif ($tokendata[1] eq "p") { # paragraph start
		  push(@tagstack,$tokendata[1]);
		  $browser->insert("end", "\n", $font) if $cardstate;
	      } elsif ($tokendata[1] eq "card") { # card begin
		  push(@tagstack,$tokendata[1]);
		  my $id = $ {$tokendata[2]}{"id"};
	          if ($card eq "") {
		      $card = "#$id";
		      $card =~ s/\#+/\#/;
		      $history->set($url=$acturl .= "$card");
		      $cardstate = 1;
		  } else {
		      $cardstate = 1 if $card eq $id;
		  }
		  if ($cardstate) {
		      my $title = "";
		      if (defined $ {$tokendata[2]}{"title"}) {
		          $title = $ {$tokendata[2]}{"title"};
	                  #print "$id -> $title\n";
			  $window->configure(-title => "$version: $title");
			  $history->settitle($title);
		      }
		  }
	          #print "wanted: $card, card-id: $id, card-state: $cardstate\n";
	      } elsif ($tokendata[1] eq "do") { # do start
		  push(@tagstack,$tokendata[1]);
		  $dostate=1;
		  if (defined $ {$tokendata[2]}{"name"}) {
		      $doname = $ {$tokendata[2]}{"name"};
                  } else {
		      $doname = $doid++;
		  }
		  $dolabel = $ {$tokendata[2]}{"label"};
	          #print "do: name: $doname, label: $dolabel\n";
	      } elsif ($tokendata[1] eq "template") { # template start
		  push(@tagstack,$tokendata[1]);
		  $cardstate=2;
	      } elsif ($tokendata[1] eq "go") { # paragraph start
		  &linktype($tokendata[1], $ {$tokendata[2]}{"href"}, $font,
                            $cardstate, $dostate, $anchorstate,
                            \%dobuttons, $doname, $dolabel);
		  unless (defined $ {$tokendata[2]}{"/"}) {
		      push(@tagstack,$tokendata[1]);
		  }
	      } elsif ($tokendata[1] eq "noop/") { # no operation
		  if ($dostate && ($cardstate == 1)) {
		      $dobuttons{$doname}->destroy 
			  if defined $dobuttons{$doname};
		      delete $backbuttons{$doname};
		      #print "Deleting $doname\n";
		  }
		  if ($anchorstate && $cardstate) {
		      my $localfont = $font;
		      $browser->tag('bind', $localfont, '<Any-Enter>' => '');
		      $browser->tag('bind', $localfont, '<1>' => '');
		  }
	      } elsif ($tokendata[1] =~ m%^(prev|refresh)/$%) { # back & reload
		  &linktype($tokendata[1], 0, $font,
                            $cardstate, $dostate, $anchorstate,
                            \%dobuttons, $doname, $dolabel);
	      } elsif ($tokendata[1] =~ m/^(b|strong)$/) { # bold, strong emph.
		  push(@tagstack,$tokendata[1]);
		  #print "tag <$tokendata[1]>: switch from $font to ";
		  push(@fontstack,$font);
		  $font =~ s/^([^=]+)=([^=]+)=([^=]+)=([^=]+)=([^=]+)$/$1=$2=bold=$4=$5/;
		  #print "$font.\n";
	      } elsif ($tokendata[1] eq "pre") { # tt
		  push(@tagstack,$tokendata[1]);
		  #print "tag <$tokendata[1]>: switch from $font to ";
		  push(@fontstack,$font);
		  $font =~ s/^([^=]+)=([^=]+)=([^=]+)=([^=]+)=([^=]+)$/ttfont=$2=$3=$4=$5/;
		  #print "$font.\n";
	      } elsif ($tokendata[1] eq "table") { # tables
		  push(@tagstack,$tokendata[1]);
		  if ($cardstate) {
		      $table++;
		      $tabledata{$table}{widget} = 
			  $scrolled->Frame(-takefocus => 0,
					   -highlightthickness => 0,
					   -relief => "flat", # raised
					   -highlightbackground => $cib,
					   @ci,
					   -borderwidth => 1);
		      $tabledata{$table}{row} = -1;
		      $tabledata{$table}{col} = -1;
		      $scrolled->window('create', "end",
					-window => $tabledata{$table}{widget},
					-align => "baseline");
		  }
	      } elsif ($tokendata[1] eq "tr") { # table rows
		  if ($cardstate) {
		      $tabledata{$table}{col} = -1;
		      $tabledata{$table}{row}++;
		  }
		  push(@tagstack,$tokendata[1]);
	      } elsif ($tokendata[1] eq "td") { # table data
		  push(@tagstack,$tokendata[1]);
		  if ($cardstate) {
		      $tabledata{$table}{col}++;
		      #print STDERR "$tabledata{$table}{row} $tabledata{$table}{col}\n";
		      $browser = $tabledata{$table}{widget}->
			  ROText(-selectforeground => $sfg,
				 -selectbackground => $sbg,
				 -selectborderwidth => 2,
				 -exportselection => 1,
				 -takefocus => 0,
				 -highlightthickness => 0,
				 -relief => "flat", # sunken
				 -highlightbackground => $cib,
				 -wrap => "word",
				 -borderwidth => 3,
				 -width => 10,
				 -height => 1,
				 -padx => 0,
				 -padx => 0,
				 @ci);
		      &generateFontTags;
		      $browser->grid(-row => $tabledata{$table}{row},
				     -column => $tabledata{$table}{col},
				     -sticky => "nsew");
		  }
	      } elsif ($tokendata[1] eq "big") { # big
		  #print "tag <$tokendata[1]>: switch from $font to ";
		  push(@fontstack,$font);
		  if (scalar grep(($_ eq "big"),@tagstack)) {
		      $fontsize = 2;
		  } else {
		      $fontsize = 1;
		  }
		  push(@tagstack,$tokendata[1]);
		  $font =~ s/^([^=]+)=([^=]+)=([^=]+)=([^=]+)=([^=]+)$/$1=$fontsize=$3=$4=$5/;
		  #print "$font.\n";
	      } elsif ($tokendata[1] eq "u") { # underline
		  push(@tagstack,$tokendata[1]);
		  #print "tag <$tokendata[1]>: switch from $font to ";
		  push(@fontstack,$font);
		  $font =~ s/^([^=]+)=([^=]+)=([^=]+)=([^=]+)=([^=]+)$/$1=$2=$3=ul=$5/;
		  #print "$font.\n";
	      } elsif ($tokendata[1] eq "small") { # big
		  #print "tag <$tokendata[1]>: switch from $font to ";
		  push(@fontstack,$font);
		  if (scalar grep(($_ eq "small"),@tagstack)) {
		      $fontsize = -2;
		  } else {
		      $fontsize = -1;
		  }
		  push(@tagstack,$tokendata[1]);
		  $font =~ s/^([^=]+)=([^=]+)=([^=]+)=([^=]+)=([^=]+)$/$1=$fontsize=$3=$4=$5/;
		  #print "$font.\n";
	      } elsif ($tokendata[1] eq "anchor") { # link
		  $link++;
		  push(@fontstack,$font);
		  $font =~ s/^([^=]+)=([^=]+)=([^=]+)=([^=]+)=([^=]+)$/$1=$2=$3=$4=link$link/;
		  #print "$localfont/$foobar.\n";
		  push(@tagstack,$tokendata[1]);
		  $anchorstate = 1;
	      } elsif ($tokendata[1] =~ m/^(img|timer)$/) { # link
		  $browser->insert("end", "[$tokendata[1]]", $font)
		      if $cardstate;
	      } elsif ($tokendata[1] eq "a") { # link
		  $link++;
		  push(@tagstack,$tokendata[1]);
		  #print "tag <$tokendata[1] href='$linkurl'>: switch from $font to ";
		  push(@fontstack,$font);
		  $font =~ s/^([^=]+)=([^=]+)=([^=]+)=([^=]+)=([^=]+)$/$1=$2=$3=$4=link$link/;
		  &linktype("go", $ {$tokendata[2]}{"href"}, $font,
                            $cardstate, 0, 1, 0, 0, 0);
	      } elsif ($tokendata[1] eq "wml") { # deck start
		  push(@tagstack,$tokendata[1]);
	      } elsif (($tokendata[1] =~ m+/$+) ||
		       (defined $ {$tokendata[2]}{"/"})) { # any other normal tag
		  &syntaxignore(@tokendata);
	      } else { # any other start tag
		  push(@tagstack,$tokendata[1]);
		  &syntaxignore(@tokendata);
	      }
		
          } elsif ($tokendata[0] eq "E") {
	      $foobar = pop(@tagstack);
	      if ($foobar eq $tokendata[1]) {
		  if ($tokendata[1] eq "p") { # paragraph end
		      $browser->insert("end", "\n", $font) if $cardstate;
		  } elsif ($tokendata[1] =~ m/^(b|pre|strong|big|small|a|u)$/) {
		      # font modifiers
		      #print "tag </$tokendata[1]>: switch from $font to ";
		      $font = pop(@fontstack);
		      #print "$font.\n";
		  } elsif ($tokendata[1] eq "anchor") {
		      # font modifiers
		      #print "tag </$tokendata[1]>: switch from $font to ";
		      $font = pop(@fontstack);
		      $anchorstate = 0;
		      #print "$font.\n";
		  } elsif ($tokendata[1] =~ /^(card|template)$/) {
		      # card and template end
                      $cardstate = 0;
	          } elsif ($tokendata[1] eq "do") { # do end
                      undef $doname;
                      undef $dolabel;
		      $dostate = 0;
	          } elsif ($tokendata[1] eq "template") { # template end
                      $cardstate = 0;
	          } elsif ($tokendata[1] eq "table") { # table end
		      if ($cardstate) {
			  $browser = $topbrowser;
			  $browser->insert("end", "\n", $font);
		      }
	          } elsif ($tokendata[1] eq "td") { # table cell end
		      if ($cardstate) {
			  my $endline = $browser->index("end");
			  $endline =~ s/\..*$//;
			  my $i = 0;
			  my $max = 0;
			  while ($i++ < $endline) {
			      my $l = length($browser->get("$i.0","$i.0 lineend"));
			      $max = $l if $l > $max;
			  }
			  $browser->configure(-width => $max,
					      -height => $endline -1);
			  $browser = $topbrowser;
		      }
	          } elsif ($tokendata[1] eq "tr") { # table row end
		      $browser = $topbrowser if $cardstate;
	          } elsif ($tokendata[1] eq "wml") { # deck end
		      $end = 1;
		      foreach (@tagstack) {
			  warn "Closing tag not found: </$_>";
		      }
		  } else {
		      &syntaxignore("/$tokendata[1]");
		  }
	      } else {
		  &syntaxwarn($foobar,$tokendata[1]);
	      }
	  }
    }

    $browser->configure(-cursor => $normalcursor);
}

sub linktype {
# Parameter: tag, href, font, cardstate, dostate, anchorstate
    my $tag  = shift;
    my $href = shift;
    my $font = shift;
    my $cardstate   = shift;
    my $dostate     = shift;
    my $anchorstate = shift;
    my $dobuttonsadr = shift;
    my $doname       = shift;
    my $dolabel      = shift;

    if ($dostate && $cardstate) {
	if ($tag eq "go") {
	    $ {$dobuttonsadr}{$doname} =
		$dotags->Button(-text => $dolabel,
				-font => $softbuttonfont,
				@ci, @buttonpadding,
				-command => sub{&fetch($href,1,0)});
	    $ {$dobuttonsadr}{$doname}->pack(-side => 'left');
	    $ {$dobuttonsadr}{$doname}->bind('<Any-Enter>' => sub {
	        &textState(URI->new_abs($href,$acturl)->as_string);});
        } elsif ($tag eq "prev/") {
            $dolabel = "--" if ($dolabel eq "") or !defined $dolabel;
	    $ {$dobuttonsadr}{$doname} = $dotags->Button(-text => $dolabel,
                                                        -font => $softbuttonfont,
							 @ci, @buttonpadding,
							 -command => \&back);
            $ {$dobuttonsadr}{$doname}->bind('<Any-Enter>' => \&backState);
            $ {$dobuttonsadr}{$doname}->configure(-state => "disabled")
                unless $history->last;
            $backbuttons{$doname} = $ {$dobuttonsadr}{$doname};
        } elsif ($tag eq "refresh/") {
            $dolabel = "-Refresh-" if ($dolabel eq "") or !defined $dolabel;
	    $ {$dobuttonsadr}{$doname} = $dotags->Button(-text => $dolabel,
                                                        -font => $softbuttonfont,
							 @ci, @buttonpadding,
							 -command => \&reload);
            $ {$dobuttonsadr}{$doname}->bind('<Any-Enter>' => \&reloadState);
        }
        $ {$dobuttonsadr}{$doname}->bind('<Any-Leave>' => \&blankState);;
        $ {$dobuttonsadr}{$doname}->pack(-side => 'left');
    }

    if ($anchorstate && $cardstate) {
	my $localfont = $font;
	my $foobar = $font;
	$foobar =~ s/=[un]l=link\d+$//;
	$browser->tag('bind', $localfont, '<Any-Leave>' =>
		      sub { shift->tag('configure', $localfont,
				       -font => $foobar, @cl,
				       -relief => "flat");
			    $browser->configure(-cursor => $textcursor);
			    &blankState;
			});
        if ($tag eq "go") {
            $browser->tag('bind', $localfont, '<Any-Enter>' =>
                sub { shift->tag('configure', $localfont,
				 -font => $foobar, @cl,
				 -relief => "raised",
				 -borderwidth => $lhbw);
		      $browser->configure(-cursor => $linkcursor);
		      &textState(URI->new_abs($href,$acturl)->as_string);
		  });
            $browser->tag('bind', $localfont, '<1>' =>
                sub { &fetch($href,1,0); });
        } elsif ($tag eq "prev/") {
            $browser->tag('bind', $localfont, '<Any-Enter>' =>
                sub {
		    if ($history->last) {
			shift->tag('configure', $localfont,
				   -font => $foobar, @cl,
				   -relief => "raised",
				   -borderwidth => $lhbw);
			$browser->configure(-cursor => $linkcursor);
			&backState;
		    }});
            $browser->tag('bind', $localfont, '<1>' => \&back);
        } elsif ($tag eq "refresh/") {
            $browser->tag('bind', $localfont, '<Any-Enter>' =>
                sub { shift->tag('configure', $localfont,
				 -font => $foobar, @cl,
				 -relief => "raised",
				 -borderwidth => $lhbw);
		      $browser->configure(-cursor => $linkcursor);
		      &reloadState;
		    });
            $browser->tag('bind', $localfont, '<1>' => \&reload);
        }
        $browser->tag('configure', $localfont,
                      -font => $foobar, @cl,
                      -relief => "flat");
    }
}


&fetch($url,1,1);
$backbutton->configure(-state => "disabled");

MainLoop;
